# stl_deque.h File Reference

## Detailed Description

This is an internal header file, included by other library headers. You should not attempt to use it directly.

Definition in file stl_deque.h.

Go to the source code of this file.

## Namespaces

- namespace std

## Defines

- #define _DEQUE_H

## Functions

- size_t __deque_buf_size (size_t __size)
- template<typename _Tp, typename _Alloc> bool operator!= (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator!= (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator!= (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> _Deque_iterator< _Tp, _Ref,
  _Ptr > operator+ (ptrdiff_t __n, const _Deque_iterator< _Tp, _Ref, _Ptr > &__x)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> _Deque_iterator< _Tp, _RefL,
  _PtrL >::difference_type operator- (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Alloc> bool operator< (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator< (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator< (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _Tp, typename _Alloc> bool operator<= (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator<= (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator<= (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _Tp, typename _Alloc> bool operator== (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator== (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator== (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _Tp, typename _Alloc> bool operator> (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator> (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator> (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _Tp, typename _Alloc> bool operator>= (const deque< _Tp, _Alloc > &__x, const deque< _Tp, _Alloc > &__y)
- template<typename _Tp, typename _RefL, typename _PtrL, typename _RefR, typename _PtrR> bool operator>= (const _Deque_iterator< _Tp, _RefL, _PtrL > &__x, const _Deque_iterator< _Tp, _RefR, _PtrR > &__y)
- template<typename _Tp, typename _Ref, typename _Ptr> bool operator>= (const _Deque_iterator< _Tp, _Ref, _Ptr > &__x, const _Deque_iterator< _Tp, _Ref, _Ptr > &__y)
- template<typename _Tp, typename _Alloc> void swap (deque< _Tp, _Alloc > &__x, deque< _Tp, _Alloc > &__y)

## Function Documentation

bool std::operator!= | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator==. Definition at line 1498 of file stl_deque.h.

bool std::operator< | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

Deque ordering relation.

Parameters:

  | x | A deque.
  | y | A deque of the same type as x.

Returns:
  True iff x is lexicographically less than y.

This is a total ordering relation. It is linear in the size of the deques. The elements must be comparable with `<`.

See std::lexicographical_compare() for how the determination is made.

Definition at line 1490 of file stl_deque.h.

References std::lexicographical_compare().

bool std::operator<= | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 1512 of file stl_deque.h.

bool std::operator== | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

Deque equality comparison.

Parameters:

  | x | A deque.
  | y | A deque of the same type as x.

Returns:
  True iff the size and elements of the deques are equal.

This is an equivalence relation. It is linear in the size of the deques. Deques are considered equivalent if their sizes are equal, and if corresponding elements compare equal.

Definition at line 1472 of file stl_deque.h.

References deque::begin(), deque::end(), std::equal(), and deque::size().

bool std::operator> | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 1505 of file stl_deque.h.

bool std::operator>= | ( | const deque< _Tp, _Alloc > & | __x,
|  | const deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

| Based on operator<. Definition at line 1519 of file stl_deque.h.

void std::swap | ( | deque< _Tp, _Alloc > & | __x,
|  | deque< _Tp, _Alloc > & | __y
| ) | `[inline]`

| See std::deque::swap(). Definition at line 1526 of file stl_deque.h. References deque::swap().